unit Unit3;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, Vcl.StdCtrls, WEBLib.StdCtrls,
  Vcl.Controls, WEBLib.ExtCtrls;

type
  TForm3 = class(TWebForm)
    WebPanel3: TWebPanel;
    Button30: TWebButton;
    WebMemo30: TWebMemo;
    procedure Button30Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation

uses
  UnitMain;

{$R *.dfm}

procedure TForm3.Button30Click(Sender: TObject);
var
  Element: String;
  Source: String;
begin
  if Assigned(FormMain.CurrentForm) then
  begin
    if (FormMain.CurrentForm <> FormMain.Form3) then
    begin

      FormMain.WebMemo1.Lines.Add('Hiding '+(FormMain.CurrentForm as TWebForm).Caption);

      // Local variables to use in JS
      Element := FormMain.CurrentFormElement;
      Source  := FormMain.CurrentFormSource;

      // Assignments for new form
      FormMain.CurrentForm        := FormMain.Form3;
      FormMain.CurrentFormElement := 'WebHTMLDiv3';
      FormMain.CurrentFormSource  := 'FormHolder3';

      // Hide currently shown form
      asm
        var oldform = document.getElementById(Element);
        document.getElementById(Source).append(oldform);

        var newform = document.getElementById('WebHTMLDiv3');
        document.getElementById('FormHolderMain').append(newform);

        setTimeout(() => { window.dispatchEvent(new Event('resize')); }, 0);
      end;

     FormMain.WebMemo1.Lines.Add('Showing '+(FormMain.CurrentForm as TWebForm).Caption);

    end;
  end;
end;

end.