unit UnitMain;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, Vcl.Controls, Vcl.StdCtrls,
  WEBLib.StdCtrls, WEBLib.ExtCtrls, WEBLib.WebCtrls;

type
  TFormMain = class(TWebForm)
    WebPanelMain: TWebPanel;
    WebMemo1: TWebMemo;
    WebPanelTop: TWebPanel;
    WebLabelMain: TWebLabel;
    WebButtonMain: TWebButton;
    WebPanelCollection: TWebPanel;
    WebGridPanel1: TWebGridPanel;
    WebPanelHolder: TWebPanel;
    Panel1: TWebPanel;
    WebHTMLDiv1: TWebHTMLDiv;
    Panel2: TWebPanel;
    WebHTMLDiv2: TWebHTMLDiv;
    Panel3: TWebPanel;
    WebHTMLDiv3: TWebHTMLDiv;
    Panel4: TWebPanel;
    WebHTMLDiv4: TWebHTMLDiv;
    procedure WebFormCreate(Sender: TObject);
    [async] procedure WebButtonMainClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Form1 :TWebForm;
    Form2 :TWebForm;
    Form3 :TWebForm;
    Form4 :TWebForm;
    CurrentForm: TWebForm;
    CurrentFormElement: String;
    CurrentFormSource: String;
  end;

var
  FormMain: TFormMain;

implementation

uses
  Unit1, Unit2, Unit3, Unit4;

{$R *.dfm}


procedure TFormMain.WebButtonMainClick(Sender: TObject);

  procedure AfterCreate(AForm: TObject);
  begin
    WebMemo1.Lines.Add((AForm as TWebForm).Caption+' Created');

    if (AForm as TWebForm).Caption = 'Form1' then
    begin
      WebMemo1.Lines.Add('Showing Form1');
      CurrentForm := Form1;
      CurrentFormElement := 'WebHTMLDiv1';
      CurrentFormSource := 'FormHolder1';
      asm
        var form = document.getElementById("WebHTMLDiv1");
        document.getElementById("FormHolderMain").append(form);
        setTimeout(() => { window.dispatchEvent(new Event('resize')); }, 0);
      end;
    end;
  end;

begin

  if not(Assigned(Form1)) then
  begin
    WebMemo1.Lines.Add('Creating Form1');
    Application.CreateForm(TForm1, WebHTMLDiv1.ElementID, Form1, @AfterCreate);
  end;

  if not(Assigned(Form2)) then
  begin
    WebMemo1.Lines.Add('Creating Form2');
    Application.CreateForm(TForm2, WebHTMLDiv2.ElementID, Form2, @AfterCreate);
  end;

  if not(Assigned(Form3)) then
  begin
    WebMemo1.Lines.Add('Creating Form3');
    Application.CreateForm(TForm3, WebHTMLDiv3.ElementID, Form3, @AfterCreate);
  end;

  if not(Assigned(Form4)) then
  begin
    WebMemo1.Lines.Add('Creating Form4');
    Application.CreateForm(TForm4, WebHTMLDiv4.ElementID, Form4, @AfterCreate);
  end;

end;

procedure TFormMain.WebFormCreate(Sender: TObject);
begin
  WebButtonMainClick(Sender);
end;

end.
